<?php
class Auswahl extends Object
{
    public /*int*/ $preis;
    public /*date*/ $datum;
    public /*Kategorie*/ $kategorie;
    public /*Angebot*/ $angebot;

    public function __construct()
    {
        parent::__construct();
        $this->kategorie = new Kategorie();
        $this->angebot = new Angebot();
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        if(parent::RemoteProcedureCall($prefix, $str))
            return true;
        if(substr($str, strlen($prefix)+11) == $prefix . '[kategorie]')
            return $this->kategorie->RemoteProcedureCall($prefix . '[kategorie]', $str);
        if(substr($str, strlen($prefix)+9) == $prefix . '[angebot]')
            return $this->angebot->RemoteProcedureCall($prefix . '[angebot]', $str);
        return false;
    }

    public function fromXml(&$xml)
    {
        parent::fromXml($xml);
        $this->preis = intval((string)($xml['preis']));
        $this->datum = strtotime((string)($xml['datum']));
        $kategorieXmlNode = $xml->kategorie;
        $kategorieTypeName = (string)$kategorieXmlNode['type'];
        $this->kategorie = new $kategorieTypeName;
        $this->kategorie->fromXml($kategorieXmlNode);
        $angebotXmlNode = $xml->angebot;
        $angebotTypeName = (string)$angebotXmlNode['type'];
        $this->angebot = new $angebotTypeName;
        $this->angebot->fromXml($angebotXmlNode);
    }

    public function toXml(&$xml)
    {
        parent::toXml($xml);
        $xml->addAttribute("preis", $this->preis);
        $xml->addAttribute("datum", $this->datum);
        $kategorieXmlNode = $xml->addChild('kategorie');
        $this->kategorie->toXml($kategorieXmlNode);
        $angebotXmlNode = $xml->addChild('angebot');
        $this->angebot->toXml($angebotXmlNode);
    }

    public function htmlView($indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Auswahl' id='$divid'>";
            echo "<div class='caption'>$divid</div>\n";
        }
        parent::htmlView($indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='int' id='preis'><div class='caption'>preis</div>" . $this->preis . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='date' id='datum'><div class='caption'>datum</div>" . date('d.m.Y', $this->datum) . "</div></div>\n";
        $this->kategorie->htmlView($indent+1, 'kategorie');
        $this->angebot->htmlView($indent+1, 'angebot');
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function htmlForm($prefix, $indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Auswahl' id='$divid'>\n";
            echo str_repeat('  ', $indent+1) . "<div class='caption'>$divid</div>\n";
        }
        parent::htmlForm($prefix, $indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='int' id='preis'><div class='caption'>preis</div><input type=\"text\" name=\"" . $prefix . "[preis]\" value=\"" . $this->preis . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='date' id='datum'><div class='caption'>datum</div><input type=\"text\" name=\"" . $prefix . "[datum]\" value=\"" . date('d.m.Y', $this->datum) . "\"/></div></div>\n";
        $this->kategorie->htmlForm($prefix . '[kategorie]' , $indent+1, 'kategorie');
        $this->angebot->htmlForm($prefix . '[angebot]' , $indent+1, 'angebot');
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function fromHttpPost(&$post)
    {
        parent::fromHttpPost($post);
        $this->preis = intval($post['preis']);
        $this->datum = strtotime($post['datum']);
        $this->kategorie->fromHttpPost($post['kategorie']);
        $this->angebot->fromHttpPost($post['angebot']);
    }
}
?>