<?php
class Person extends Object
{
    public /*string*/ $vorname;
    public /*string*/ $nachname;
    public /*Adresse*/ $adresse;
    public /*string*/ $telefonnummer;
    public /*string*/ $handynummer;
    public /*date*/ $geburtsdatum;
    public /*string*/ $konfession;

    public function __construct()
    {
        parent::__construct();
        $this->adresse = new Adresse();
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        if(parent::RemoteProcedureCall($prefix, $str))
            return true;
        if(substr($str, strlen($prefix)+9) == $prefix . '[adresse]')
            return $this->adresse->RemoteProcedureCall($prefix . '[adresse]', $str);
        return false;
    }

    public function fromXml(&$xml)
    {
        parent::fromXml($xml);
        $this->vorname = (string)($xml['vorname']);
        $this->nachname = (string)($xml['nachname']);
        $adresseXmlNode = $xml->adresse;
        $adresseTypeName = (string)$adresseXmlNode['type'];
        $this->adresse = new $adresseTypeName;
        $this->adresse->fromXml($adresseXmlNode);
        $this->telefonnummer = (string)($xml['telefonnummer']);
        $this->handynummer = (string)($xml['handynummer']);
        $this->geburtsdatum = strtotime((string)($xml['geburtsdatum']));
        $this->konfession = (string)($xml['konfession']);
    }

    public function toXml(&$xml)
    {
        parent::toXml($xml);
        $xml->addAttribute("vorname", $this->vorname);
        $xml->addAttribute("nachname", $this->nachname);
        $adresseXmlNode = $xml->addChild('adresse');
        $this->adresse->toXml($adresseXmlNode);
        $xml->addAttribute("telefonnummer", $this->telefonnummer);
        $xml->addAttribute("handynummer", $this->handynummer);
        $xml->addAttribute("geburtsdatum", $this->geburtsdatum);
        $xml->addAttribute("konfession", $this->konfession);
    }

    public function htmlView($indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Person' id='$divid'>";
            echo "<div class='caption'>$divid</div>\n";
        }
        parent::htmlView($indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='vorname'><div class='caption'>vorname</div>" . htmlspecialchars($this->vorname) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='nachname'><div class='caption'>nachname</div>" . htmlspecialchars($this->nachname) . "</div></div>\n";
        $this->adresse->htmlView($indent+1, 'adresse');
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='telefonnummer'><div class='caption'>telefonnummer</div>" . htmlspecialchars($this->telefonnummer) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='handynummer'><div class='caption'>handynummer</div>" . htmlspecialchars($this->handynummer) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='date' id='geburtsdatum'><div class='caption'>geburtsdatum</div>" . date('d.m.Y', $this->geburtsdatum) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='konfession'><div class='caption'>konfession</div>" . htmlspecialchars($this->konfession) . "</div></div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function htmlForm($prefix, $indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Person' id='$divid'>\n";
            echo str_repeat('  ', $indent+1) . "<div class='caption'>$divid</div>\n";
        }
        parent::htmlForm($prefix, $indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='vorname'><div class='caption'>vorname</div><input type=\"text\" name=\"" . $prefix . "[vorname]\" value=\"" . htmlspecialchars($this->vorname) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='nachname'><div class='caption'>nachname</div><input type=\"text\" name=\"" . $prefix . "[nachname]\" value=\"" . htmlspecialchars($this->nachname) . "\"/></div></div>\n";
        $this->adresse->htmlForm($prefix . '[adresse]' , $indent+1, 'adresse');
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='telefonnummer'><div class='caption'>telefonnummer</div><input type=\"text\" name=\"" . $prefix . "[telefonnummer]\" value=\"" . htmlspecialchars($this->telefonnummer) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='handynummer'><div class='caption'>handynummer</div><input type=\"text\" name=\"" . $prefix . "[handynummer]\" value=\"" . htmlspecialchars($this->handynummer) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='date' id='geburtsdatum'><div class='caption'>geburtsdatum</div><input type=\"text\" name=\"" . $prefix . "[geburtsdatum]\" value=\"" . date('d.m.Y', $this->geburtsdatum) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='konfession'><div class='caption'>konfession</div><input type=\"text\" name=\"" . $prefix . "[konfession]\" value=\"" . htmlspecialchars($this->konfession) . "\"/></div></div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function fromHttpPost(&$post)
    {
        parent::fromHttpPost($post);
        $this->vorname = $post['vorname'];
        $this->nachname = $post['nachname'];
        $this->adresse->fromHttpPost($post['adresse']);
        $this->telefonnummer = $post['telefonnummer'];
        $this->handynummer = $post['handynummer'];
        $this->geburtsdatum = strtotime($post['geburtsdatum']);
        $this->konfession = $post['konfession'];
    }
}
?>